; Trr... TrigPass - IW3FQG

; v 1.0 (02/04/92)      Initial release
; v 1.1 (21/03/94)      Added AUTO Password support

IFDEF ??version ; is Tasm?
        VERSION M510
        JUMPS
ENDIF

MODEL TINY

DATASEG

SendPassID      db 'SendPass',0
Hellomsg        db 13,10,'Trr... TrigPass 1.1 - IW3FQG',13,10,'$'
NonResMsg       db 7,13,10,'SendPass is not loaded!',13,10,'$'
theId           dw  ?
theCmd          db  ?

Helpmsg         db 13,10
                db 'Usage: TRIGPASS cmd',13,10,13,10
                db 'cmd:',13,10,13,10
                db '  0 - Send TRUE password',13,10
                db '  1 - Send FALSE password',13,10
                db '  2 - Change current password',13,10
                db '  3 - Show current password',13,10
                db '  4 - Send using AUTO Passowrd',13,10,'$'

CODESEG

STARTUPCODE
        mov     dx, OFFSET Hellomsg             ; stampa Hellomsg con la
        mov     ah, 9                           ; funzione 21h del DOS
        int     21h

        mov     si, 0080h                       ; punta alla linea di comando
        lodsb                                   ; preleva la lunghezza
        or      al, al                          ; c'e' qualcosa?
        jz      Help                            ; No, stampa l'Help
        mov     cl, al                          ; Si, trasferisce il numero
        sub     ch, ch                          ; di caratteri nel contatore.
@@:
        lodsb                                   ; carica il primo carattere
        cmp     al, ' '
        je      @B                              ; se e' uno spazio avanza di uno
        cmp     al, '0'
        jl      Help                            ; se < 0 o > 4 stampa Help
        cmp     al, '4'
        jg      Help
        sub     al, '0'                         ; calcola comando
        mov     theCmd, al                      ; salva comando
        jmp     goCmd

Help:                                           ; Stampa Helpmsg
        mov     dx, OFFSET Helpmsg
        mov     ah, 9
        int     21h
        jmp     stop                            ; e termina

goCmd:
        mov     ax, 5453h
        mov     si, OFFSET SendPassID
        xor     cx, cx
        xor     bx, bx
        int     2fh

        cmp     ax,-1                           ; if AX==ffff, we're already
        jne     not_res                         ;     resident

        mov     theId,cx                        ; save theId returned in cx

        mov     ax, 5453h                       ; get the Param of TSR
        mov     bx, 01h
        int     2fh                             ; resuting struct is in
                                                ; ES:BX

        mov     al, theCmd                      ; load the cmd in al

        mov     BYTE PTR [es:bx+10h],al         ; set in the param

        mov     ax, 5453h
        mov     bx, 22h
        int     2fh
        mov     al,0
        jmp     stop

not_res:
        mov     dx, OFFSET NonResMsg            ; stampa Hellomsg con la
        mov     ah, 9                           ; funzione 21h del DOS
        int     21h
        mov     al, 01h
stop:
        mov     ah, 4Ch                         ; termina e torna al dos
        int     21h

END

